/*
    Data area of m__o starter.
    Comments with '$' as the first letter
    describe appearence of parameters
    on the screen.
*/

/*$t Starter*/
typedef struct m___o_Data {
  /*$t Iteration data*/
  int itmap;            /* superposition number*/
		        /*$ 1 | + n Superposition | "1" %Code(SPECCL_MSUP) */
  /*$t Initial point*/
  double *Tdef;		/* if the user did not specify time */
			/*$ 1-%Time | + n time | "0" */
  double *T;		/* if he/she did */
			/*$ %Time | + n @Time { $Time} | "0" %LCode(Time) */
  double *X;		/* Init point: phase components */
			/*$ %Phase | + n @Phase { $Phase} | "0" %LCode(Phase) */
  double *P;		/* Init point: parameters components */
			/*$ %Par | + n @Par { $Par} | "0" %LCode(Par) */

  /*$t User defined functions*/    
  char *ActiveUserTest;	/*$ %UserFunc | + S ignore monitor | @UserFunc { $UserFunc} | "0" %Code(SPECCL_AUS) */
  /*$t Set initial point*/
  FuncPar(void,SetInitPoint,(struct m___o_Data * _ptr));
			/*$ 1 | + f SetInitPoint | "" */
} m__o_Data, * m__o_DataPtr;
